<?php

namespace Drupal\image_deriver\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines an image optimize processor annotation object.
 *
 * Plugin Namespace: Plugin\ImageDeriver.
 *
 * @Annotation
 */
class ImageDeriver extends Plugin {

  /**
   * The plugin ID.
   *
   * @var string
   */
  public $id;

  /**
   * The human-readable name of the image optimize processor.
   *
   * @ingroup plugin_translatable
   *
   * @var \Drupal\Core\Annotation\Translation
   */
  public $label;

  /**
   * A brief description of the image optimize processor.
   *
   * This will be shown when adding or configuring this image optimize processor.
   *
   * @ingroup plugin_translatable
   *
   * @var \Drupal\Core\Annotation\Translation
   */
  public $description = '';

  /**
   * The format of the image.
   *
   * @var string
   */
  public $format;

}
