<?php

namespace Drupal\image_deriver\Attribute;

use Attribute;
use Drupal\Component\Plugin\Attribute\Plugin;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Attribute class for Image Deriver plugins.
 */
#[Attribute(Attribute::TARGET_CLASS)]
class ImageDeriver extends Plugin {
  /**
   * Constructs a Block attribute.
   *
   * @param string $id
   *   The plugin ID.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $label
   *   The administrative label of the block.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $description
   *   (optional) The category in the admin UI where the block will be listed.
   */
  public function __construct(
    public readonly string $id,
    public readonly ?TranslatableMarkup $label = NULL,
    public readonly ?TranslatableMarkup $description = NULL,
    public readonly ?string $format = NULL,
  ) {}
}
