<?php

namespace Drupal\image_deriver\Entity;

use Drupal\image\Entity\ImageStyle;
use Drupal\imageapi_optimize\Entity\ImageStyleWithPipeline;

class ImageApiStyleWithDeriver extends ImageStyleWithPipeline {

  use ImageStyleDerivativeHandlerTrait;

  /**
   * {@inheritdoc}
   */
  public function createDerivative($original_uri, $derivative_uri) {
    $result = ImageStyle::createDerivative($original_uri, $derivative_uri);
    if ($result) {
      // Apply image type deriver.
      if ($this->requiresDeriver($original_uri, $derivative_uri)) {
        $this->getImageDeriverPlugin($derivative_uri)->convert($derivative_uri);
        clearstatcache();
      }
      // Continue with ImageAPI Optimize processing.
      // Apply the pipeline to the $derivative_uri.
      if ($this->hasPipeline()) {
        $this->getPipelineEntity()->applyToImage($derivative_uri);
      }
    }

    // Always return the result of the parent class processing.
    return $result;
  }

}
