<?php

namespace Drupal\image_deriver\Entity;

use Drupal\image\Entity\ImageStyle;

class ImageStyleWithDeriver extends ImageStyle {

  /**
   * {@inheritdoc}
   */
  public function createDerivative($original_uri, $derivative_uri) {
    $result = parent::createDerivative($original_uri, $derivative_uri);
    if ($result) {
      // Apply image type deriver.
      if ($this->requiresDeriver($original_uri, $derivative_uri)) {
        $this->getImageDeriverPlugin($derivative_uri)->convert($derivative_uri);
        clearstatcache();
      }
    }
    // Always return the result of the parent class processing.
    return $result;
  }

}
