<?php

namespace Drupal\image_deriver;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * Plugin manager for Image Deriver plugins.
 */
class ImageDeriverPluginManager extends DefaultPluginManager {

  /**
   * Constructs a new ImageDeriverPluginManager.
   *
   * @param \Traversable $namespaces
   *   An object containing the root paths keyed by namespace.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   The cache backend to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler service.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/ImageDeriver', $namespaces, $module_handler, 'Drupal\image_deriver\ImageDeriverPluginInterface', 'Drupal\image_deriver\Annotation\ImageDeriver');

    $this->alterInfo('image_deriver');
    $this->setCacheBackend($cache_backend, 'image_deriver_plugins');
  }
}
