<?php

namespace Drupal\image_deriver\Plugin\ImageDeriver;

use Drupal\image_deriver\Attribute\ImageDeriver;

/**
 * Example implementation of an Image Deriver plugin using attributes.
 */
/**
 * @ImageDeriver(
 *   id = "webp",
 *   format = "webp",
 *   label = @Translation("WebP"),
 *   description = @Translation("WebP image format.")
 * )
 */
class WebP extends ImageDeriverBase {

  /**
   * convert the image derivation.
   */
  public function convert($derivative_uri) {
    // Unable to use core convert because quality is automatically set to 80.
    // @see https://www.drupal.org/project/drupal/issues/3320689
    if ($image = $this->getImage($derivative_uri)) {
      // @todo Add ImageMagick support.
      imagewebp($image->getToolkit()->getImage(), $derivative_uri, 100);
      // Fix issue where sometimes image fails to generate.
      if (filesize($derivative_uri) % 2 == 1) {
        file_put_contents($derivative_uri, "\0", FILE_APPEND);
      }
    }
  }

}
